#ifndef __MyEvent_h__
#define __MyEvent_h__

#include <TClonesArray.h>

class MyChannel;

class MyEvent : public TObject
{
public:
	MyEvent():
		nbrBytes(0),
		sampInter(0),
		nbrSamples(0),
		delayTime(0),
		TrigChan(0),
		TrigLevel(0),
		TrigSlope(0),
		usedChans(0),
		ChanCombUsedChans(0),
		nbrConPerCh(0),
		channels("MyChannel",8),
		EventID(0),
		horpos(0),
		nbrChannels(0)			{}

	MyEvent(size_t nChans):
		nbrBytes(0),
		sampInter(0),
		nbrSamples(0),
		delayTime(0),
		TrigChan(0),
		TrigLevel(0),
		TrigSlope(0),
		usedChans(0),
		ChanCombUsedChans(0),
		nbrConPerCh(0),
		channels("MyChannel",8),
		EventID(0),
		horpos(0),
		nbrChannels(0)			{setChans(nChans);}
	~MyEvent()					{}	

protected:
	MyEvent& operator=(const MyEvent& in)	{return *this;}
	MyEvent(const MyEvent& in)				{}

public:
	void  clear();
	void  setChans(size_t nChans);
	short getNbrOfChannels() const			{return nbrChannels;}
	MyChannel *getChannel(long idx) const	{return reinterpret_cast<MyChannel*>(channels[idx]);}

	Long64_t getEventID() const				{return EventID;}
	double   getHorpos() const				{return horpos;}
	void     setNbrBytes(size_t in)			{nbrBytes=in;}
	short    getNbrBytes() const			{return nbrBytes;}
	double   getSampleInterval() const		{return sampInter;}
	void     setSampleInterval(double in)	{sampInter=in;}
	long     getNbrSamples() const			{return nbrSamples;}
	void     setNbrSamples(long in) 		{nbrSamples=in;}
	double   getDelayTime() const			{return delayTime;}
	short    getTriggerChannel() const		{return TrigChan;}
	double   getTriggerLevel() const		{return TrigLevel;}
	short    getTriggerSlope() const		{return TrigSlope;}
	long     getUsedChannels() const		{return usedChans;}
	long     getChanCombUsedChannels()const	{return ChanCombUsedChans;}
	short    getNbrConvPerChans() const		{return nbrConPerCh;}

private:
	//these variables could go into a header//	
	short  nbrBytes;						//nbr of bits of the adc values (either 8 or 16)
	double sampInter;						//the time between two consecutive points (in ns)
	long   nbrSamples;						//nbr of Points (multiplied by the sampInter it will give the timewindow in ns)
	double delayTime;						//the delay of the trigger with respect to the window
	short  TrigChan;						//the Triggering Channel
	double TrigLevel;						//the trigger Level from the Offset
	short  TrigSlope;						//which Slope was used by the Trigger
	long   usedChans;						//Bitmask discribing which Channels have been recorded 
	long   ChanCombUsedChans;				//Bitmask discribing which Converters per Channel have been used
	short  nbrConPerCh;						//tells how many converts per channel have been used

	//these variables need to be stored for each event//
	Long64_t EventID;						//an id for this event. It is just the time the event was recorded
	double   horpos;						//the horpos value for this event
	
	short nbrChannels;						//nbr of Channels in this event
	TClonesArray channels;					//Container for all Channels

	ClassDef(MyEvent,1)						//An Event
};

#endif