#ifndef __MyPuls_h__
#define __MyPuls_h__

#include <TObject.h>

class MyChannel;

class MyPuls : public TObject
{
public:
	MyPuls():
		parentChannel(0),
		data(0),
		dataLength(0),
		idxFiP(0)		{}

	MyPuls(MyChannel* pc):
		parentChannel(pc),
		data(0),
		dataLength(0),
		idxFiP(0)		{}

	~MyPuls()			{}

protected:
	MyPuls& operator=(const MyPuls& in)		{return *this;}
	MyPuls(const MyPuls& in)				{}

public:
	void setIndexToFirstPoint(long in)		{idxFiP=in;}
	long getIndexToFirstPoint()	const		{return idxFiP;}
	void appendLength(long in);
	long getLength() const;
	void setData(char* in)					{data = in;}
	char*getData() const					{return data;}
	void Clear(Option_t* = "")				{data=0;dataLength=0;}

	MyChannel* getParentChannel()			{return parentChannel;}


private:
	int  dataLength;			//length of part of Trace
	char*data;					//[dataLength] part of Trace
	long idxFiP;				//index to first point in the whole trace in units of the original data type

	MyChannel *parentChannel;	//pointer to the channel that this puls belongs to

	ClassDef(MyPuls,1)			//Subset of Channels' Trace
};
#endif